var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { wirteMd } from './wirte-md';
import { writeFile } from 'fs/promises';
import { renameFoldPath, renameFilePath } from './rename-path';
import { createConsola } from 'consola';
import { changePath, wirteJsNodes } from './change-path';
import { markFile, deletMarkAll, witeMarkFile } from './mark-file';
import { getRouterArrs } from './get-router';
import path from 'path';
const logger = createConsola({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
export function getMdAction(md) {
    console.log('\x1B[36m%s\x1B[0m', '*** location: ', `${rootPath}/readme-md.md`);
    wirteMd(md, `${rootPath}/readme-md.md`);
}
function checkFold() {
    const foldPath = path.resolve('./').replace(/\\/g, '/');
    const foldArrs = foldPath.split('/');
    const foldName = foldArrs.pop();
    if (foldName === 'pages') {
        return;
    }
    if (foldName !== 'src') {
        logger.error('changePath需要在src目录下运行命令! ');
        process.exit(1);
    }
}
export function changePathAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        yield changePath(nodes);
    });
}
export function changeAbsolutePathAction() {
    return __awaiter(this, void 0, void 0, function* () { });
}
export function changesuffixAction(nodes, nochangePath) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        yield changePath(nodes, nochangePath);
    });
}
export function markFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        const routers = yield getRouterArrs();
        yield writeFile(rootPath + '/router-file.js', 'const router=' + JSON.stringify(routers), { encoding: 'utf8' });
        if (routers) {
            yield markFile(nodes, routers);
            yield wirteJsNodes(JSON.stringify(nodes), rootPath + '/readme-file.js');
        }
    });
}
export function witeFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        const routers = yield getRouterArrs();
        if (routers) {
            yield markFile(nodes, routers);
            yield witeMarkFile(nodes, routers);
        }
    });
}
export function deletMarkAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        yield deletMarkAll(nodes, 'mark');
    });
}
export function renameFoldAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        renameFoldPath(nodes);
    });
}
export function renameFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        renameFilePath(nodes);
    });
}
export function generateAllAction(nodes, md) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        const routers = yield getRouterArrs();
        if (routers) {
            getMdAction(md);
            yield changePathAction(nodes);
            yield markFileAction(nodes);
            yield witeMarkFile(nodes, routers);
            yield wirteJsNodes(JSON.stringify(nodes), rootPath + '/readme-file.js');
        }
    });
}
//# sourceMappingURL=command-actions.js.map