var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { findNodes } from './mark-file';
import fs from 'fs-extra';
import { createConsola } from 'consola';
const logger = createConsola({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
export function markWriteFile(nodes, name, path) {
    return __awaiter(this, void 0, void 0, function* () {
        const node = findNodes(nodes, path);
        if (!node || node.copyed)
            return;
        node.copyed = true;
        if (node.belongTo.length > 0) {
            yield setDispFileNew(path, name);
        }
        if (node.imports) {
            for (const element of node.imports) {
                if (yield fs.pathExists(element)) {
                    yield markWriteFile(nodes, name, element);
                }
                else {
                    logger.error(`${element} 文件不存在`);
                }
            }
        }
    });
}
export function setDispFileNew(pathN, name) {
    return __awaiter(this, void 0, void 0, function* () {
        const relative = pathN.replace(rootPath, '');
        const writeFileName = `${rootPath}/${name}${relative}`;
        try {
            if (yield fs.pathExists(writeFileName))
                return;
            yield fs.copy(pathN, writeFileName);
            logger.success('写入文件success! : ', writeFileName);
        }
        catch (err) {
            logger.error('文件写入失败');
        }
    });
}
//# sourceMappingURL=mark-write-file.js.map