var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import fs from 'fs';
import path from 'path';
import { getFileNodes, getNote } from './get-file';
import { createConsola } from 'consola';
const logger = createConsola({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
export function wirteMd(data, filePath) {
    const file = path.resolve(rootPath, filePath);
    fs.writeFile(file, data, { encoding: 'utf8' }, () => {
        logger.success('Write successful');
    });
}
export function getCountMd(datas) {
    let rowTotleNumber = 0;
    let sizeTotleNumber = 0;
    const coutObj = {};
    function getDeatle(nodes) {
        nodes.forEach((obj) => {
            if (obj.children)
                getDeatle(obj.children);
            else if (obj.suffix && obj.rowSize && obj.size) {
                if (!coutObj.hasOwnProperty(obj.suffix))
                    coutObj[obj.suffix] = 0;
                coutObj[obj.suffix]++;
                rowTotleNumber += obj.rowSize;
                sizeTotleNumber += obj.size;
            }
        });
    }
    getDeatle(datas);
    return {
        rowTotleNumber,
        sizeTotleNumber,
        coutObj
    };
}
function format(num) {
    var reg = /\d{1,3}(?=(\d{3})+$)/g;
    return (num + '').replace(reg, '$&,');
}
export function setCountMd(obj) {
    const { rowTotleNumber, sizeTotleNumber, coutObj } = obj;
    let countMd = '😍 代码总数统计：\n';
    let totle = 0;
    for (const key in coutObj) {
        const ele = coutObj[key];
        totle += ele;
        countMd += `后缀是 ${key} 的文件有 ${ele} 个\n`;
    }
    countMd += `总共有 ${totle} 个文件\n`;
    let md = `总代码行数有: ${format(rowTotleNumber)}行,
总代码字数有: ${format(sizeTotleNumber)}个\n`;
    md = countMd + md;
    return md;
}
export function getMd(option) {
    return __awaiter(this, void 0, void 0, function* () {
        logger.success('👉  命令运行位置: ' + process.cwd() + '\n');
        const nodes = yield getFileNodes(rootPath, option);
        const countMdObj = getCountMd(nodes);
        const coutMd = setCountMd(countMdObj);
        logger.success(coutMd);
        const note = getNote(nodes);
        const md = note.join('') + '\n';
        if (md.length > 0) {
            logger.success('🀄️  生成MarkDown完毕 !');
        }
        return { md: md + coutMd, nodes };
    });
}
//# sourceMappingURL=wirte-md.js.map