#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_actions_1 = require("./command-actions");
const wirte_md_1 = require("./wirte-md");
const cli_1 = __importDefault(require("../../script/cli"));
const handle_1 = __importDefault(require("../../script/cli/handle"));
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const options = (0, cli_1.default)(process.argv);
        const { ignores: ignore, includes: include } = (0, handle_1.default)(options);
        const { md, nodes } = yield (0, wirte_md_1.getMd)({ ignore, include });
        yield (0, command_actions_1.generateAllAction)(nodes, md);
    });
}
main();
//# sourceMappingURL=agmd.js.map