"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAllAction = exports.renameFileAction = exports.renameFoldAction = exports.deletMarkAction = exports.witeFileAction = exports.markFileAction = exports.changesuffixAction = exports.changeAbsolutePathAction = exports.changePathAction = exports.getMdAction = void 0;
const wirte_md_1 = require("./wirte-md");
const promises_1 = require("fs/promises");
const rename_path_1 = require("./rename-path");
const consola_1 = require("consola");
const change_path_1 = require("./change-path");
const mark_file_1 = require("./mark-file");
const get_router_1 = require("./get-router");
const path_1 = __importDefault(require("path"));
const logger = (0, consola_1.createConsola)({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
function getMdAction(md) {
    console.log('\x1B[36m%s\x1B[0m', '*** location: ', `${rootPath}/readme-md.md`);
    (0, wirte_md_1.wirteMd)(md, `${rootPath}/readme-md.md`);
}
exports.getMdAction = getMdAction;
function checkFold() {
    const foldPath = path_1.default.resolve('./').replace(/\\/g, '/');
    const foldArrs = foldPath.split('/');
    const foldName = foldArrs.pop();
    if (foldName === 'pages') {
        return;
    }
    if (foldName !== 'src') {
        logger.error('changePath需要在src目录下运行命令! ');
        process.exit(1);
    }
}
function changePathAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        yield (0, change_path_1.changePath)(nodes);
    });
}
exports.changePathAction = changePathAction;
function changeAbsolutePathAction() {
    return __awaiter(this, void 0, void 0, function* () { });
}
exports.changeAbsolutePathAction = changeAbsolutePathAction;
function changesuffixAction(nodes, nochangePath) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        yield (0, change_path_1.changePath)(nodes, nochangePath);
    });
}
exports.changesuffixAction = changesuffixAction;
function markFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        const routers = yield (0, get_router_1.getRouterArrs)();
        yield (0, promises_1.writeFile)(rootPath + '/router-file.js', 'const router=' + JSON.stringify(routers), { encoding: 'utf8' });
        if (routers) {
            yield (0, mark_file_1.markFile)(nodes, routers);
            yield (0, change_path_1.wirteJsNodes)(JSON.stringify(nodes), rootPath + '/readme-file.js');
        }
    });
}
exports.markFileAction = markFileAction;
function witeFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        const routers = yield (0, get_router_1.getRouterArrs)();
        if (routers) {
            yield (0, mark_file_1.markFile)(nodes, routers);
            yield (0, mark_file_1.witeMarkFile)(nodes, routers);
        }
    });
}
exports.witeFileAction = witeFileAction;
function deletMarkAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, mark_file_1.deletMarkAll)(nodes, 'mark');
    });
}
exports.deletMarkAction = deletMarkAction;
function renameFoldAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        (0, rename_path_1.renameFoldPath)(nodes);
    });
}
exports.renameFoldAction = renameFoldAction;
function renameFileAction(nodes) {
    return __awaiter(this, void 0, void 0, function* () {
        (0, rename_path_1.renameFilePath)(nodes);
    });
}
exports.renameFileAction = renameFileAction;
function generateAllAction(nodes, md) {
    return __awaiter(this, void 0, void 0, function* () {
        checkFold();
        const routers = yield (0, get_router_1.getRouterArrs)();
        if (routers) {
            getMdAction(md);
            yield changePathAction(nodes);
            yield markFileAction(nodes);
            yield (0, mark_file_1.witeMarkFile)(nodes, routers);
            yield (0, change_path_1.wirteJsNodes)(JSON.stringify(nodes), rootPath + '/readme-file.js');
        }
    });
}
exports.generateAllAction = generateAllAction;
//# sourceMappingURL=command-actions.js.map