"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRouterArrs = exports.getRouter = exports.getAllRouter = exports.getRouterFilePath = void 0;
const promises_1 = require("fs/promises");
const consola_1 = require("consola");
const path_1 = __importDefault(require("path"));
const router_utils_1 = require("../utils/router-utils");
const logger = (0, consola_1.createConsola)({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
function getRouterFilePath(dir) {
    return __awaiter(this, void 0, void 0, function* () {
        const routes = [];
        function finder(p) {
            return __awaiter(this, void 0, void 0, function* () {
                const files = yield (0, promises_1.readdir)(p);
                for (const val of files) {
                    const fPath = path_1.default.join(p, val).replace(/\\/g, '/');
                    const stats = yield (0, promises_1.stat)(fPath);
                    if (stats.isDirectory()) {
                        yield finder(fPath);
                    }
                    else if (stats.isFile()) {
                        routes.push(fPath);
                    }
                }
            });
        }
        yield finder(dir);
        return routes;
    });
}
exports.getRouterFilePath = getRouterFilePath;
function getAllRouter(dir) {
    return __awaiter(this, void 0, void 0, function* () {
        const filePaths = yield getRouterFilePath(dir);
        const routers = [];
        for (const filePath of filePaths) {
            const routerItems = yield getRouter(filePath);
            routers.push(...routerItems);
        }
        return routers;
    });
}
exports.getAllRouter = getAllRouter;
function getRouter(routerPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const routers = [];
        try {
            yield (0, promises_1.access)(routerPath);
            const fileContent = yield (0, promises_1.readFile)(routerPath, 'utf-8');
            const lines = fileContent.split(/\n/g);
            let currentPath = '';
            let currentComponent = '';
            lines.forEach((line) => {
                if (line.includes('//'))
                    return;
                const tempPath = (0, router_utils_1.parseRouterPath)(line);
                if (tempPath)
                    currentPath = tempPath;
                const tempComponent = (0, router_utils_1.parseComponentPath)(line);
                if (tempComponent)
                    currentComponent = tempComponent;
                if (currentPath && currentComponent) {
                    routers.push({ path: currentPath, component: currentComponent });
                    currentPath = '';
                    currentComponent = '';
                }
            });
        }
        catch (error) {
            console.error('读取路由配置时出错:', error);
        }
        return routers;
    });
}
exports.getRouter = getRouter;
function getRouterArrs() {
    return __awaiter(this, void 0, void 0, function* () {
        const pathName = `${rootPath}/classify.js`;
        const dir = `${rootPath}/router`;
        let routers = null;
        try {
            if (yield (0, promises_1.stat)(pathName)) {
                routers = yield Promise.resolve(`${pathName}`).then(s => __importStar(require(s)));
            }
            else {
                routers = [
                    {
                        name: 'mark',
                        router: yield getAllRouter(dir)
                    }
                ];
            }
        }
        catch (error) {
            logger.error('根路径没有发现 classify.js，并且 src 里面没有 router 文件，现在退出');
            process.exit(1);
        }
        return routers;
    });
}
exports.getRouterArrs = getRouterArrs;
//# sourceMappingURL=get-router.js.map