"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMd = exports.setCountMd = exports.getCountMd = exports.wirteMd = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const get_file_1 = require("./get-file");
const consola_1 = require("consola");
const logger = (0, consola_1.createConsola)({
    level: 4
});
const rootPath = process.cwd().replace(/\\/g, '/');
function wirteMd(data, filePath) {
    const file = path_1.default.resolve(rootPath, filePath);
    fs_1.default.writeFile(file, data, { encoding: 'utf8' }, () => {
        logger.success('Write successful');
    });
}
exports.wirteMd = wirteMd;
function getCountMd(datas) {
    let rowTotleNumber = 0;
    let sizeTotleNumber = 0;
    const coutObj = {};
    function getDeatle(nodes) {
        nodes.forEach((obj) => {
            if (obj.children)
                getDeatle(obj.children);
            else if (obj.suffix && obj.rowSize && obj.size) {
                if (!coutObj.hasOwnProperty(obj.suffix))
                    coutObj[obj.suffix] = 0;
                coutObj[obj.suffix]++;
                rowTotleNumber += obj.rowSize;
                sizeTotleNumber += obj.size;
            }
        });
    }
    getDeatle(datas);
    return {
        rowTotleNumber,
        sizeTotleNumber,
        coutObj
    };
}
exports.getCountMd = getCountMd;
function format(num) {
    var reg = /\d{1,3}(?=(\d{3})+$)/g;
    return (num + '').replace(reg, '$&,');
}
function setCountMd(obj) {
    const { rowTotleNumber, sizeTotleNumber, coutObj } = obj;
    let countMd = '😍 代码总数统计：\n';
    let totle = 0;
    for (const key in coutObj) {
        const ele = coutObj[key];
        totle += ele;
        countMd += `后缀是 ${key} 的文件有 ${ele} 个\n`;
    }
    countMd += `总共有 ${totle} 个文件\n`;
    let md = `总代码行数有: ${format(rowTotleNumber)}行,
总代码字数有: ${format(sizeTotleNumber)}个\n`;
    md = countMd + md;
    return md;
}
exports.setCountMd = setCountMd;
function getMd(option) {
    return __awaiter(this, void 0, void 0, function* () {
        logger.success('👉  命令运行位置: ' + process.cwd() + '\n');
        const nodes = yield (0, get_file_1.getFileNodes)(rootPath, option);
        const countMdObj = getCountMd(nodes);
        const coutMd = setCountMd(countMdObj);
        logger.success(coutMd);
        const note = (0, get_file_1.getNote)(nodes);
        const md = note.join('') + '\n';
        if (md.length > 0) {
            logger.success('🀄️  生成MarkDown完毕 !');
        }
        return { md: md + coutMd, nodes };
    });
}
exports.getMd = getMd;
//# sourceMappingURL=wirte-md.js.map