"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDependencies = exports.parseComponentPath = exports.parseRouterPath = void 0;
const promises_1 = require("fs/promises");
function parseRouterPath(line) {
    const pathRegex = /path:\s*['"]([^'"]+)['"]/;
    const match = line.match(pathRegex);
    return match ? match[1] : '';
}
exports.parseRouterPath = parseRouterPath;
function parseComponentPath(line) {
    const componentRegex = /component:\s*\(\)\s*=>\s*import\(['"]([^'"]+)['"]\)/;
    const match = line.match(componentRegex);
    return match ? match[1] : '';
}
exports.parseComponentPath = parseComponentPath;
function getDependencies(packageJsonPath) {
    return __awaiter(this, void 0, void 0, function* () {
        let dependencies = [];
        if (packageJsonPath) {
            try {
                yield (0, promises_1.access)(packageJsonPath);
                const pkg = JSON.parse(yield (0, promises_1.readFile)(packageJsonPath, 'utf-8'));
                dependencies = Object.keys(pkg.dependencies || {}).concat(Object.keys(pkg.devDependencies || {}));
            }
            catch (error) {
                console.error(error);
            }
        }
        return dependencies;
    });
}
exports.getDependencies = getDependencies;
//# sourceMappingURL=router-utils.js.map